From f6b6f1bc80d6657d6a98a078425c7d3d569de5e9 Mon Sep 17 00:00:00 2001
From: Blue Swirl <blauwirbel@gmail.com>
Date: Sun, 27 Dec 2009 20:52:39 +0000
Subject: [PATCH] Sparc64: move APB PCI memory base to correct location

Signed-off-by: Blue Swirl <blauwirbel@gmail.com>
---
 hw/apb_pci.c |    2 ++
 1 files changed, 2 insertions(+), 0 deletions(-)

diff --git a/hw/apb_pci.c b/hw/apb_pci.c
index fe8faa6..f05308b 100644
--- a/hw/apb_pci.c
+++ b/hw/apb_pci.c
@@ -225,6 +225,8 @@ PCIBus *pci_apb_init(target_phys_addr_t special_base,
     d->host_state.bus = pci_register_bus(&d->busdev.qdev, "pci",
                                          pci_apb_set_irq, pci_pbm_map_irq, pic,
                                          0, 32);
+    pci_bus_set_mem_base(d->host_state.bus, mem_base);
+
     pci_create_simple(d->host_state.bus, 0, "pbm");
     /* APB secondary busses */
     *bus2 = pci_bridge_init(d->host_state.bus, PCI_DEVFN(1, 0),
-- 
1.5.6.5